# coding: utf-8

"""
TInvest Autofollow API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing_extensions import Self

from ttech_autofollow.models.instrument_type import InstrumentType


class PortfolioPosition(BaseModel):
    """
    Позиция портфеля
    """  # noqa: E501

    instrument_uid: StrictStr = Field(
        description="Идентификатор инструмента", alias="instrumentUid"
    )
    position_uid: StrictStr = Field(
        description="Идентификатор позиции", alias="positionUid"
    )
    ticker: StrictStr = Field(description="Тикер инструмента")
    instrument_type: InstrumentType = Field(alias="instrumentType")
    lots: Union[StrictFloat, StrictInt] = Field(description="Количество лотов")
    changed_at: datetime = Field(description="Дата и время", alias="changedAt")
    __properties: ClassVar[List[str]] = [
        "instrumentUid",
        "positionUid",
        "ticker",
        "instrumentType",
        "lots",
        "changedAt",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PortfolioPosition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PortfolioPosition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "instrumentUid": obj.get("instrumentUid"),
                "positionUid": obj.get("positionUid"),
                "ticker": obj.get("ticker"),
                "instrumentType": obj.get("instrumentType"),
                "lots": obj.get("lots"),
                "changedAt": obj.get("changedAt"),
            }
        )
        return _obj
